# $Id: NautilusBookmarks.pm,v 1.1 2003/12/23 16:46:25 uid68241 Exp $
# This file is part of PerlPanel.
# 
# PerlPanel is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# PerlPanel is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with PerlPanel; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
package Gnome2::NautilusBookmarks;
use Gtk2;
use XML::Simple;
use base 'Gtk2::Button';
use strict;

sub new {
	my $package = shift;
	my $self = $package->SUPER::new;
	bless($self, $package);

	my $child = shift;
	$self->add($child);

	$self->signal_connect('clicked', sub { $self->show_menu });

	return $self;
}

sub show_menu {
	my $self = shift;
	my $bookmarks = XMLin(sprintf('%s/.nautilus/bookmarks.xml', $ENV{HOME}));
	my @data = ( ['/', undef, undef, undef, '<Branch>'] );
	foreach my $name (sort keys %{$bookmarks->{bookmark}}) {
		push(@data, [
			'/'.$name,
			undef,
			sub { system("nautilus \"$bookmarks->{bookmark}->{$name}->{uri}\" &") },
			undef,
			'<StockItem>',
			'gtk-jump-to',
		]);
	}
	my $factory = Gtk2::ItemFactory->new('Gtk2::Menu', '<main>', undef);
	$factory->create_items(@data);
	my $menu = $factory->get_widget('<main>');
	$menu->popup(undef, undef, undef, 0, $self->get_parent, undef);
	return 1;
}

1;
